// 2006-04-30 programmeerimisvõistlus
// Ülesanne: MÜNDIPOKS
// Autor: Ahto Truu
// Testitud: GCC 3.2 / MinGW

// väga kehv lahendus, teeb alati juhusliku käigu

#include <iostream>
#include <cstdlib>
#include <cassert>
using namespace std;

int r; // ribade arv laual
int b[4]; // mitu vaba kohta on meie mündi taga
int f[4]; // mitu vaba kohta on meie mündi ees

// väljastab jooksva seisu, silumiseks
void dump() {
    for (int i = 0; i < r; ++i)
        cerr << " " << b[i] << "." << f[i];
    cerr << endl;
}

// kas mäng on läbi?
bool done() {
    for (int i = 0; i < r; ++i)
        if (b[i] + f[i] > 0)
            return false;
    return true;
}

// teeb juhusliku käigu
void random(int & i, int & k) {
    int x = 0;
    for (i = 0; i < r; ++i)
        x += b[i] + f[i];
    x = rand() % x;
    for (i = 0; i < r; ++i) {
        if (x < b[i]) {
            k = x - b[i];
            return;
        }
        x -= b[i];
        if (x < f[i]) {
            k = f[i] - x;
            return;
        }
        x -= f[i];
    }
    assert(false);
}

int main() {
    int p, i, k;
    cin >> r;
    for (i = 0; i < r; ++i) {
        cin >> k;
        b[i] = 0; f[i] = k - 2;
    }
    cin >> p;
    while (true) {
        if (p == 1) {
            if (done()) {
                cout << "0 0" << endl;
                break;
            }
            random(i, k);
            f[i] -= k; b[i] += k;
            cout << i + 1 << " " << k << endl;
        }
        cin >> i >> k;
        if (i == 0 && k == 0)
            break;
        f[i - 1] -= k;
        p = 1;
    }
    return 0;
}
