{ 2006-04-30 programmeerimisvõistlus                                        }
{ Ülesanne: LUKUD                                                           }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'lukud.sis';
   valf = 'lukud.val';
   max = 100;                            { maksimaalne lubatud koopa suurus }

var
   n, m : integer;                                         { kaardi mõõtmed }
   a : array [0..max+1, 0..max+1] of char;                    { koopa kaart }
   k : array [0..max+1, 0..max+1] of integer;         { alampuu võtmete arv }
   x : array [0..max+1, 0..max+1] of integer;    { alampuu väljapääsude arv }
   f : text;                          { failimuutuja sisendi/väljundi jaoks }
   i, j : integer;
   si, sj : integer;                               { lähtekoha koordinaadid }
   tp : integer;                                     { väljapääsutee pikkus }
   qq : boolean;                 { testide silumiseks: kas vastus on ühene? }

procedure otsi(i, j : integer);
var c : char;
begin
   if (i < 1) or (i > n) or (j < 1) or (j > m) then exit;
   c := a[i, j]; a[i, j] := '.';
   if (c <> '0') and (c <> 'K') and (c <> 'F') then exit;
   otsi(i - 1, j); otsi(i + 1, j); otsi(i, j - 1); otsi(i, j + 1);
   k[i, j] := k[i - 1, j] + k[i + 1, j] + k[i, j - 1] + k[i, j + 1];
   if c = 'K' then k[i, j] := k[i, j] + 1;
   x[i, j] := x[i - 1, j] + x[i + 1, j] + x[i, j - 1] + x[i, j + 1];
   if c = 'F' then x[i, j] := 1;
end;

procedure lisa(d : char);
begin
   write(f, d); tp := tp + 1;
end;

procedure labi(i, j : integer);
var q : integer;
begin
   if (i < 1) or (i > n) or (j < 1) or (j > m) then exit;
   k[i, j] := 0; x[i, j] := 0;
   q := 0;
   if (k[i - 1, j] > 0) and (x[i - 1, j] = 0) then begin
      lisa('N'); labi(i - 1, j); lisa('S');
      q := q + 1;
   end;
   if (k[i + 1, j] > 0) and (x[i + 1, j] = 0) then begin
      lisa('S'); labi(i + 1, j); lisa('N');
      q := q + 1;
   end;
   if (k[i, j - 1] > 0) and (x[i, j - 1] = 0) then begin
      lisa('W'); labi(i, j - 1); lisa('E');
      q := q + 1;
   end;
   if (k[i, j + 1] > 0) and (x[i, j + 1] = 0) then begin
      lisa('E'); labi(i, j + 1); lisa('W');
      q := q + 1;
   end;
   if q > 1 then qq := false;
   if (x[i - 1, j] > 0) then begin
      lisa('N'); labi(i - 1, j);
   end;
   if (x[i + 1, j] > 0) then begin
      lisa('S'); labi(i + 1, j);
   end;
   if (x[i, j - 1] > 0) then begin
      lisa('W'); labi(i, j - 1);
   end;
   if (x[i, j + 1] > 0) then begin
      lisa('E'); labi(i, j + 1);
   end;
end;

begin
   { loeme kaardi sisse }
   assign(f, sisf); reset(f);
   readln(f, n, m);
   for i := 0 to n + 1 do
      for j := 0 to m + 1 do begin
         a[i, j] := '1';
         k[i, j] := 0;
         x[i, j] := 0;
      end;
   for i := 1 to n do begin
      for j := 1 to m do begin
         read(f, a[i, j]);
         if a[i, j] = 'S' then begin
            si := i; sj := j;
         end;
      end;
      readln(f);
   end;
   close(f);

   { otsime kõik võtmed ja väljapääsu sügavuti läbimisega }
   a[si, sj] := '0';
   otsi(si, sj);

   { konstrueerime vastuse ja väljastame selle jooksvalt }
   assign(f, valf); rewrite(f);
   tp := 0; qq := true;
   labi(si, sj);
   writeln(f);
   close(f);
   write(stderr, tp, ' sammu, ');
   if qq then writeln(stderr, 'ühene') else writeln(stderr, 'pole ühene');
end.
